
#ifndef _include_bleifrei_platform_Keyboard_hpp_
#define _include_bleifrei_platform_Keyboard_hpp_ 


// includes
#include "../platform/windows.hpp"

#include "../Singleton.hpp"

namespace bleifrei {
	namespace input {

		class KeyboardEventListener {
		public:
			virtual void onKeyTyped(char c);
		};

		class Keyboard : public Singleton<Keyboard>
		{
			friend class Singleton<Keyboard>;
		public:
			enum Key {
				Escape = VK_ESCAPE,
				Pause = VK_PAUSE,
				Left = VK_LEFT,
				Right = VK_RIGHT,
				Up = VK_UP,
				Down = VK_DOWN,
				Space = VK_SPACE,
				LeftShift = VK_LSHIFT,
				LeftControl = VK_LCONTROL,
				PrintScreen = VK_SNAPSHOT
			};

			bool init(void);
			void destroy(void);

			bool isDown(int key);

			void update(void);
			void keyTypedEvent(char c);

			void setEventListener(KeyboardEventListener *eventListener)		{ this->eventListener = eventListener;	}

			KeyboardEventListener *eventListener;

		private:
			Keyboard(void) {}
			~Keyboard(void) {}
		};

		inline
		void
		Keyboard::keyTypedEvent(char c)
		{
			if (eventListener) eventListener->onKeyTyped(c);
		}

	}
}


#endif //_include_bleifrei_platform_Keyboard_hpp_
