/** 
 * bleifrei utility library
 *
 * Copyright (C) 2003 Ulf Borgenstam, Jonas Svensson.
 *
 * Do not distribute. If you know someone interested in obtaining these sources
 * please have them contact us.
 */

#ifndef _include_bleifrei_console_hpp_
#define _include_bleifrei_console_hpp_ 

// includes
#include <list>
#include <string>

#include "../Singleton.hpp"

namespace bleifrei {
	namespace io {

		class Console : public Singleton<Console> {
			friend class Singleton<Console>;
		public:
			class Line {
			public:
				Line(float r, float g, float b, const std::string &str) : r(r), g(g), b(b), text(str) {}
				float r, g, b;
				std::string text;
			};

			bool init(int maxLines = 30);
			void destroy(void);

			int getLineCount(void)											{ return (int)lines.size();				}
			std::list<Line> &getLines(void)									{ return lines;							}

			void printf(float r, float g, float b, const char *str, ...);
			void print(float r, float g, float b, const std::string &str);

		private:
			Console(void) {};
			~Console(void) {};

			void setConsoleColor(float r, float g, float b);

			int maxLines;
			std::list<Line> lines;
		};

	}
}

#endif //_include_bleifrei_console_hpp_
