
#ifndef _include_GUI_hpp_
#define _include_GUI_hpp_ 


// includes
#include "bleifrei/gui/GUIManager.hpp"

namespace bleifrei {
	namespace gfx {
		class Font;
	}
}

class Frame;
class Label;
class MousePointer;
class ProgressIndicator;
class Toolbar;

enum GUIState
{
	GUIStateLoading,
	GUIStateMain,
	GUIStateMax
};

class GUI :
	public bleifrei::gui::GUIManager
{
public:
	GUI(void);
	~GUI(void);

	void render(void);

	void showCursor(void);
	void hideCursor(void);

	void setState(GUIState state);
	void setLoadingProgressMax(int max);
	void setLoadingProgress(int progress);
	void setLoadingText(const std::string &text);

private:
	static void enableOrtho(int width, int height);
	static void disableOrtho(void);

	bleifrei::gfx::Font *m_font;
	MousePointer *m_mousePointer;

	Frame *m_mainFrame;
	Frame *m_loadingFrame;
	Label *m_actionLabel;
	Toolbar *m_toolbar;
	ProgressIndicator *m_loadingbar;
};


#endif //_include_GUI_hpp_