
// includes
#include "bleifrei/gfx/opengl.hpp"
#include "bleifrei/platform/System.hpp"
#include "bleifrei/tex/TextureManager.hpp"

#include "Toolbar.hpp"

using namespace bleifrei::gui;
using namespace bleifrei::platform;
using namespace bleifrei::tex;
using namespace std;

Toolbar::Toolbar(const string &imageName, int width, int height) :
	m_animationPosition(0.0f)
{
	setFlag(GUIComponentFlagStretchHorizontal);
	move(0, 1 - height);
	resize(width, height);
	m_texture = TextureManager::getInstance().load(imageName);
}

void Toolbar::onPaintBackground(int absx, int absy)
{
	m_texture->bind();

	glEnable(GL_BLEND);
	glDisable(GL_ALPHA_TEST);
	glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
	glColor4f(1, 1, 1, 1);
	glBegin(GL_QUADS);
		glTexCoord2f(0, 1);
		glVertex2i(absx, absy);
		glTexCoord2f(0, 0);
		glVertex2i(absx, absy + getHeight());
		glTexCoord2f(1, 0);
		glVertex2i(absx + getWidth(), absy + getHeight());
		glTexCoord2f(1, 1);
		glVertex2i(absx + getWidth(), absy);
	glEnd();
	glDisable(GL_BLEND);
}

void Toolbar::onPaintOverlay(int absx, int absy)
{
}

void
Toolbar::onUpdate(void)
{
	const float animationSpeed = 10.0f;

	if (isMouseOver())
	{
		m_animationPosition += System::getInstance().getFrameTime() * animationSpeed;
		if (m_animationPosition > 1.0f) m_animationPosition = 1.0f; 
	}
	else 
	{
		m_animationPosition -= System::getInstance().getFrameTime() * animationSpeed;
		if (m_animationPosition < 0.0f) m_animationPosition = 0.0f; 
	}

	move(0, (int)((1 - m_animationPosition) * (1 - getHeight())));
}
